;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Intro story.
;
;	@com.wudsn.ide.asm.mainsourcefile=RGBA.asm

	.proc story

cnt	= $14

char	= $80

.if .not .def ntsc_mode
wait_time_second	= 50
wait_time_click		= 2
.else
wait_time_second	= 60
wait_time_click		= 3

.endif

	.proc main
	.proc text_loop
lda_ptr	lda text
 	sta char
	beq text_end
	inw lda_ptr+1
	cmp #text.WAIT
	beq no_print
	cmp #text.SOUND
	bne no_sound
	lda #setvbv.immediate
	ldx #>vbi
	ldy #<vbi
	jsr setvbv
	jmp no_wait
no_sound
	jsr print_char
no_print
	lda char
	cmp #' '
	beq no_click
	cmp #text.WAIT
	beq no_click
	ora #$60
	jsr click
no_click
	lda char
	cmp #text.WAIT
	bne no_wait
	lda #wait_time_second
	.byte $2c
no_wait
	lda #wait_time_click
	jsr wait
	beq text_loop
	.endp
text_end
	rts
	.endp
	
	.proc vbi
	jsr sound.play
	jmp sysvbv
	.endp

	.proc wait	;IN: <A>=number of frames
	clc
	adc cnt
loop	cmp cnt
	bne loop
	rts
	.endp

	.proc print_char;IN: char, changes <A>, <X>, <Y>
	lda $e407	;Use PUT_CHAR from E: handler
	pha
	lda $e406
	pha
	lda char
	rts
	.endp

	.proc click
loop	sta consol
	ldx vcount
delay	cpx vcount
	beq delay
	sbc #1
	bpl loop
	rts
	.endp

	.proc fade_out
loop	lda color1
	and #15
	beq no_dec_709
	sec
	sbc #1
no_dec_709
	sta color1
	sta colpf1

	lda color2
	and #15
	beq no_dec_710
	sec
	sbc #1
no_dec_710
	sta color2
	sta colpf2

	ora color1
	beq done
	lda #3
	jsr wait
	jmp loop
done	lda #0
	sta sdmctl
	lda #25
	jmp wait
	.endp

	.local text
	EOL = 155
	WAIT = 156
	SOUND = 157
	CLEAR = 125
	BACKSPACE = 126

	.byte CLEAR, WAIT, EOL
	.byte '2012-08-15 GREY',EOL, WAIT
	.byte 'The chicks look amazing! And this',EOL
	.byte 'color background is just awesome.',EOL, WAIT
	.byte 'Don''t tell me that this fullscreen...',EOL
	.byte 'will move with those chicks in front?',EOL, WAIT
	.byte 'Naaah, cannot be...',EOL, WAIT
	.byte EOL
	.byte '2012-08-16 JAC!',EOL, WAIT
	.byte 'Yeah, in fact it really cannot move',EOL
	.byte 'because this is TIP and the CPU is',EOL
	.byte '100% busy during the display already.',EOL, WAIT
	.byte 'But I can still think of some things',EOL
	.byte 'to do with this...',EOL, WAIT
	.byte EOL, SOUND
	.byte '2012-12-08 YOU at Sillyventure 2k12',EOL, WAIT
	.byte '16k intro.',EOL, WAIT
	.byte '64k stock machine from 1984.',EOL, WAIT
	.byte 'Pure Atari Power without the Price.',EOL, WAIT
	.byte 'Turn SATURATION on TV to MAX!',EOL, WAIT
	.byte EOL
	.byte 'PRESS SPACE.',WAIT,WAIT,WAIT,WAIT
:12	.byte BACKSPACE
	.byte 'Just kidding.',WAIT,' It''s 2012 :-)',EOL
	.byte 0
	.endl

	.endp

