;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Hires interlace effects.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.proc tip

or_mask_11_left	= effects_base
or_mask_11_right= effects_base+$100
or_mask_11	= effects_base+$200
or_mask_09_left	= effects_base+$300
or_mask_09_right= effects_base+$400
or_mask_09	= effects_base+$500
or_mask_10_left	= effects_base+$600
or_mask_10_right= effects_base+$700
or_mask_10	= effects_base+$800
bar_squares	= effects_base+$900
shade_increase	= effects_base+$a00
shade_buffer	= effects_base+$1700	; aligned to $1000

	.print "SHADE_BUFFER: ", shade_buffer
	m_assert_align shade_buffer $1000


	xcount	= x1	;X position
	ycount	= x2	;Y position
	sm_ptr	= p1
	sm09_ptr  = p2
	sm10_ptr  = p3
	sm11_ptr  = p4


	.proc init_masks	;IN: <X>=callback, low byte, <Y>=callback, high byte
	stx jsr_adr
	sty jsr_adr+1

	ldx #0
init_masks
jsr_adr	= *+1
	jsr $ffff	;IN: <X>=0...255, OUT: <A>=$00..fe (even values)
	pha

	lsr
	lsr
	lsr
	lsr
	tay
	lda rainbow_colors,y
	sta or_mask_11_right,x
	asl
	asl
	asl
	asl
	sta or_mask_11_left,x
	ora or_mask_11_right,x
	sta or_mask_11,x

	pla
	and #$0e
	pha
	sta or_mask_09_right,x
	asl
	asl
	asl
	asl
	sta or_mask_09_left,x
	ora or_mask_09_right,x
	sta or_mask_09,x

	pla
	lsr
	sne
	lda #tip_black8
	sta or_mask_10_right,x
	asl
	asl
	asl
	asl
	sta or_mask_10_left,x
	ora or_mask_10_right,x
	sta or_mask_10,x

	inx
	bne init_masks
	rts

	.local rainbow_colors
	.byte $03,$02,$01,$0f,$0e,$0d,$0c,$0b,$0a,$09,$08,$07,$06,$05,$04,$00
	.endl

	.endp


	.proc plot_pixel
	sta color

	lda ycount

	.if .def debug
	cmp #tip_lines
	bcc y_less
	jam
y_less
	.endif

	lsr
	lsr
	tay

	lda xcount
	.if .def debug
	cmp #tip_pixel_width
	bcc x_less
	jam
x_less
	.endif
	lsr
	jsr cut.check_mask
	bne skip

	ldy ycount
	lda tip_sm_offset_lo,y
	sta p1
	sta p2
	sta p3
	clc
	lda tip_sm_offset_hi,y
	adc #>tip_sm09
	sta p1+1
	adc #>[tip_sm10-tip_sm09]
	sta p2+1
	adc #>[tip_sm11-tip_sm10]
	sta p3+1

color	= *+1
	ldx #0
	lda xcount
	lsr
	tay
	lda (p3),y
	bcs right_pixel

	and #$0f			;Plot left pixel
	ora or_mask_11_left,x
	sta (p3),y
	lda (p1),y
	and #$0f
	ora or_mask_09_left,x
	sta (p1),y
	lda (p2),y
	and #$0f
	ora or_mask_10_left,x
	sta (p2),y
	rts

right_pixel				;Plot right pixel
	and #$f0
	ora or_mask_11_right,x
	sta (p3),y
	lda (p1),y
	and #$f0
	ora or_mask_09_right,x
	sta (p1),y
	lda (p2),y
	and #$f0
	ora or_mask_10_right,x
	sta (p2),y

skip	rts

	.endp

	icl "tip/RGBA-TIP-Bars.asm"
	icl "tip/RGBA-TIP-Shades.asm"

	.endp	;End of tip
