;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Created 2010-09-19/2010-12-06 for the Sillyventure 2012 in Gdansk.
;
;	Standalong TIP viewer.

height	= 100

nmien	= $d40e
wsync	= $d40a
prior	= $d01b

TIP_gr09frame = $4010
TIP_gr10frame = $52b8
TIP_gr11frame = $6560

        org     $80
a1      org     *+2
even    org     *+1
cnt     org     *+1

	org $2000

	.proc main
	jsr TIP_makeDisplayList
	jsr TIP_showImage
	jmp *
	.endp

	.proc TIP_makeDisplayList

	jsr initDList
	lda #120
	sub #height
	and:tax #$fe
	lda #0
TIP_emptyln
	cpx #0
	beq TIP_emptyln2
	jsr storeDListx
	dex:bpl TIP_emptyln
TIP_emptyln2
	lda #$80
	jsr storeDListx
	ldx #height
TIP_makeDList_1
	jsr TIP_makeDList_11
	lda a1
	add <TIP_gr09frame
	jsr storeDList1
	lda a1+1
	adc >TIP_gr09frame
	jsr storeDList1
	lda a1
	add <TIP_gr10frame
	jsr storeDList2
	lda a1+1
	adc >TIP_gr10frame
	jsr storeDList2
	dex:beq TIP_makeDList_2
	jsr nextDListLine
	jsr TIP_makeDList_11
	lda a1
	add <TIP_gr10frame
	jsr storeDList1
	lda a1+1
	adc >TIP_gr10frame
	jsr storeDList1
	lda a1
	add <TIP_gr09frame
	jsr storeDList2
	lda a1+1
	adc >TIP_gr09frame
	jsr storeDList2
	dex:beq TIP_makeDList_2
	jsr nextDListLine
	bne TIP_makeDList_1
TIP_makeDList_2

        lda     #$41
        jsr     storeDListx
        lda     <dl1
        jsr     storeDListx
        lda     >dl1
        jmp     storeDListx

TIP_makeDList_11
	lda #$4f
	jsr storeDListx
	lda a1
	add <TIP_gr11frame
	jsr storeDListx
	lda a1+1
	adc >TIP_gr11frame
	jsr storeDListx
	lda #$cf
	jmp storeDListx


initDList
        mwa     #dl1    storeDList1+1
        mwa     #dl2    storeDList2+1
        mwa     #$00    a1
        rts

storeDListx
        jsr     storeDList2
 
storeDList1
        sta     dl1
        inw     storeDList1+1
        rts

storeDList2
        sta     dl2
        inw     storeDList2+1
        rts

nextDListLine
        lda     #40
        add:sta a1
        scc:inc a1+1
        rts
 
	.endp
	
	.proc TIP_showImage
	ldx #8
	mva:rpl clrt10,x $02c0,x-
	mwa #TIP_dli    $0200

        mwa #dl1 $0230

	mwa #0  $021a
	mwa #TIP_vbl    $0228
	inc $021a
	asl nmien

	mva #34 $022f
	jmp *

clrt10  dta 0,2,4,6,8,10,12,14,0

TIP_vbl mva #1  $021a
	eor:sta even
	sta cnt
	bne TIP_v0
	mwa #dl1 $d402
	rts
TIP_v0  mwa #dl2 $d402
	rts

TIP_dli pha
	lda #%11000001
	sta wsync
	sta prior
	inc:lda cnt
	and #1
	beq v2
	lda #%01000001
	sta wsync
	sta prior
	pla
	rti
v2  lda #%10000001
	sta wsync
	sta prior
	pla
	rti
	.endp
	
frame_offset = +9
frame_size = 40*height

	org TIP_gr09frame
	ins "tip/chicks-jakub-2.5.tip",frame_offset+frame_size*0, frame_size
	org TIP_gr10frame
	ins "tip/chicks-jakub-2.5.tip",frame_offset+frame_size*1, frame_size
	org TIP_gr11frame
	ins "tip/chicks-jakub-2.5.tip",frame_offset+frame_size*2, frame_size

        org     $8000
dl1     org     *+1024
dl2     org     *+1024

	run main
